<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Float-point FFT Utilities</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Float-point FFT Utilities</div>  </div>
</div><!--header-->
<div class="contents">

<p>The functions to facilitate floating point FFT.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga02dc3f2198325a32621d465e667a074f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___f_f_t___f_l_o_a_t.html#ga02dc3f2198325a32621d465e667a074f">mmwavelib_windowing1DFltp</a> (uint32_t nSamplesValidPerChirp, uint32_t fftSize1D, int16_t fftWin1D[restrict], int16_t *inputPtr, float32_t *outputPtr)</td></tr>
<tr class="memdesc:ga02dc3f2198325a32621d465e667a074f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_windowing1DFltp.  <a href="#ga02dc3f2198325a32621d465e667a074f">More...</a><br /></td></tr>
<tr class="separator:ga02dc3f2198325a32621d465e667a074f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7571f2d0c92fd40ea66f977a420205d8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___f_f_t___f_l_o_a_t.html#ga7571f2d0c92fd40ea66f977a420205d8">mmwavelib_windowing2DFltp</a> (uint32_t fftSize1D, float32_t inWin, float32_t inOutPtr[restrict])</td></tr>
<tr class="memdesc:ga7571f2d0c92fd40ea66f977a420205d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_windowing2DFltp.  <a href="#ga7571f2d0c92fd40ea66f977a420205d8">More...</a><br /></td></tr>
<tr class="separator:ga7571f2d0c92fd40ea66f977a420205d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4ec7cd9fd58d0ec4628f520ae6a99bf6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___f_f_t___f_l_o_a_t.html#ga4ec7cd9fd58d0ec4628f520ae6a99bf6">mmwavelib_chirpProcWin2DFxdpinFltOut</a> (uint32_t fftSize1D, int16_t inWin, void *inoutPtr)</td></tr>
<tr class="memdesc:ga4ec7cd9fd58d0ec4628f520ae6a99bf6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_chirpProcWin2DFxdpinFltOut.  <a href="#ga4ec7cd9fd58d0ec4628f520ae6a99bf6">More...</a><br /></td></tr>
<tr class="separator:ga4ec7cd9fd58d0ec4628f520ae6a99bf6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5129c459d93224bf7635bcacf0c885e9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___f_f_t___f_l_o_a_t.html#ga5129c459d93224bf7635bcacf0c885e9">mmwavelib_dopplerProcWin2DFxdpinFltOut</a> (uint32_t length, int16_t *restrict inputPtr, int16_t *restrict windowPtr, float32_t *restrict outputPtr)</td></tr>
<tr class="memdesc:ga5129c459d93224bf7635bcacf0c885e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_dopplerProcWin2DFxdpinFltOut.  <a href="#ga5129c459d93224bf7635bcacf0c885e9">More...</a><br /></td></tr>
<tr class="separator:ga5129c459d93224bf7635bcacf0c885e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>The functions to facilitate floating point FFT. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga4ec7cd9fd58d0ec4628f520ae6a99bf6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mmwavelib_chirpProcWin2DFxdpinFltOut </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize1D</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int16_t&#160;</td>
          <td class="paramname"><em>inWin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>inoutPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_chirpProcWin2DFxdpinFltOut. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Windowing function for 2D FFT per antenna per chirp, the input is fixed point complex, prepare for the input to floating point 2D FFT.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize1D</td><td>: 1D FFT size </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inWin</td><td>: Input 2D windowing coefficient for this chirp, fixed point. </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">inoutPtr</td><td>: Input is 32 bits complex value, with int16 I/Q, Output is written in place, and it is floating point, in the same I/Q order as the input buffer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd>(1) inoutPtr must be aligned to 8 byte boundary. </dd>
<dd>
(2) Input is at the first half of the buffer pointed by inoutPtr, in 32 bits complex value,</dd></dl>
<p>Cycles 2.18*fftSize (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga5129c459d93224bf7635bcacf0c885e9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mmwavelib_dopplerProcWin2DFxdpinFltOut </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int16_t *restrict&#160;</td>
          <td class="paramname"><em>inputPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int16_t *restrict&#160;</td>
          <td class="paramname"><em>windowPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *restrict&#160;</td>
          <td class="paramname"><em>outputPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_dopplerProcWin2DFxdpinFltOut. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Windowing function for fixed point complex input and floating point complex output.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>: the number of complex values in the input array. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inputPtr</td><td>: Pointer to 16-bit I/Q input array. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">windowPtr</td><td>: Pointer to 16-bit real windowing coefficients buffer. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outputPtr</td><td>: Pointer to floating-point output buffer after windowing, with same I/Q order as the input I/Q buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd>(1) inputPtr and outputPtr must be aligned to 8 byte boundary. </dd>
<dd>
(2) windowPtr must be aligned to 4 byte boundary. </dd>
<dd>
(3) Window is assumed to be symmetric so only length/2 coefficients are needed. </dd>
<dd>
(4) length must be multiple of 4.</dd></dl>
<p>Cycles 1.55*length + 45 (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga02dc3f2198325a32621d465e667a074f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mmwavelib_windowing1DFltp </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>nSamplesValidPerChirp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize1D</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int16_t&#160;</td>
          <td class="paramname"><em>fftWin1D</em>[restrict], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int16_t *&#160;</td>
          <td class="paramname"><em>inputPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>outputPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_windowing1DFltp. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Windowing function for 1D FFT per antenna per chirp, prepare for the input to floating point 1D FFT.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">nSamplesValidPerChirp</td><td>: Number of valid samples per chirp </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize1D</td><td>: 1D FFT size, must be power of 2 </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftWin1D</td><td>: Input pointer to Windowing real array (16 bit) of length nSamplesValidPerChirp/2+1. It is assumed the window is symmetric. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inputPtr</td><td>: Input 32 bits complex signal array, 16bits I/Q. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">outputPtr</td><td>: Output complex signal array, floating point I/Q, same order as the input</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void </dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd>(1)Input Windowing array (fftWin1D) is 4 byte alligned. (2)Input data (inputPtr) is 8 byte aligned.</dd></dl>
<p>Cycles 2.87*length+56(cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga7571f2d0c92fd40ea66f977a420205d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mmwavelib_windowing2DFltp </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize1D</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>inWin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>inOutPtr</em>[restrict]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_windowing2DFltp. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Windowing function for 2D FFT per antenna per chirp, prepare for the input to floating 2D FFT.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize1D</td><td>: 1D FFT size </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inWin</td><td>: Input 2D windowing coefficient for this chirp, in float point. </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">inOutPtr</td><td>: Float-point complex-value input array, Output is written inplace</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void</dd></dl>
<p>Cycles 1.98*fftsize (cgt 8.1.3) </p>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
